# Configuration for telegraf agent
[agent]
  ## Default data collection interval for all inputs
  interval = "10s"
  ## Rounds collection interval to 'interval'
  ## ie, if interval="10s" then always collect on :00, :10, :20, etc.
  round_interval = true

  ## Telegraf will send metrics to outputs in batches of at most
  ## metric_batch_size metrics.
  ## This controls the size of writes that Telegraf sends to output plugins.
  metric_batch_size = 1000

  ## For failed writes, telegraf will cache metric_buffer_limit metrics for each
  ## output, and will flush this buffer on a successful write. Oldest metrics
  ## are dropped first when this buffer fills.
  ## This buffer only fills when writes fail to output plugin(s).
  metric_buffer_limit = 10000

  ## Collection jitter is used to jitter the collection by a random amount.
  ## Each plugin will sleep for a random time within jitter before collecting.
  ## This can be used to avoid many plugins querying things like sysfs at the
  ## same time, which can have a measurable effect on the system.
  collection_jitter = "0s"

  ## Default flushing interval for all outputs. Maximum flush_interval will be
  ## flush_interval + flush_jitter
  flush_interval = "10s"
  ## Jitter the flush interval by a random amount. This is primarily to avoid
  ## large write spikes for users running a large number of telegraf instances.
  ## ie, a jitter of 5s and interval 10s means flushes will happen every 10-15s
  flush_jitter = "0s"

  ## By default or when set to "0s", precision will be set to the same
  ## timestamp order as the collection interval, with the maximum being 1s.
  ##   ie, when interval = "10s", precision will be "1s"
  ##       when interval = "250ms", precision will be "1ms"
  ## Precision will NOT be used for service inputs. It is up to each individual
  ## service input to set the timestamp at the appropriate precision.
  ## Valid time units are "ns", "us" (or "µs"), "ms", "s".
  precision = ""

  ################################################################################
  # Logging
  ################################################################################
  debug = false
  quiet = false
  logtarget = "file"
  logfile = "/var/log/telegraf/telegraf.log"
  logfile_rotation_interval = "24h"
  logfile_rotation_max_archives = 30

  ## Override default hostname, if empty use os.Hostname()
  hostname = ""
  ## If set to true, do no set the "host" tag in the telegraf agent.
  omit_hostname = false
[[outputs.influxdb_v2]]	
  ## The URLs of the InfluxDB cluster nodes.
  ##
  ## Multiple URLs can be specified for a single cluster, only ONE of the
  ## urls will be written to each interval.
  ## urls exp: http://127.0.0.1:8086
  urls = ["http://10.50.1.105:8086"]

  ## Token for authentication.
  token = "$INFLUX_TOKEN"

  ## Organization is the name of the organization you wish to write to; must exist.
  organization = "telegraf"

  ## Destination bucket to write into.
  bucket = "telegraf"

# TESTED

####################################################################################################
[[inputs.disk]]

#disk
#
#    tags:
#        fstype (filesystem type)
#        device (device file)
#        path (mount point path)
#        mode (whether the mount is rw or ro)
#    fields:
#        free (integer, bytes)
#        total (integer, bytes)
#        used (integer, bytes)
#        used_percent (float, percent)
#        inodes_free (integer, files)
#        inodes_total (integer, files)
#        inodes_used (integer, files)

  ## By default stats will be gathered for all mount points.
  ## Set mount_points will restrict the stats to only the specified mount points.
  mount_points = ["/", "/gringotts"]
  ## Ignore mount points by filesystem type.
  ignore_fs = ["tmpfs", "devtmpfs", "devfs", "overlay", "aufs", "squashfs"]

####################################################################################################
[[inputs.filecount]]

#filecount
#
#    tags:
#        directory (the directory path)
#    fields:
#        count (integer)
#        size_bytes (integer)


  interval = "1m"
  ## Directory to gather stats about.
  ##   deprecated in 1.9; use the directories option
  # directory = "/var/cache/apt/archives"

  ## Directories to gather stats about.
  ## This accept standard unit glob matching rules, but with the addition of
  ## ** as a "super asterisk". ie:
  ##   /var/log/**    -> recursively find all directories in /var/log and count files in each directories
  ##   /var/log/*/*   -> find all directories with a parent dir in /var/log and count files in each directories
  ##   /var/log       -> count all files in /var/log and all of its subdirectories
  directories = [{{ telegraf_filecount_dirs }}]

  ## Only count files that match the name pattern. Defaults to "*".
  name = "*"

  ## Count files in subdirectories. Defaults to true.
  recursive = true

  ## Only count regular files. Defaults to true.
  regular_only = true

  ## Follow all symlinks while walking the directory tree. Defaults to false.
  follow_symlinks = false

  ## Only count files that are at least this size. If size is
  ## a negative number, only count files that are smaller than the
  ## absolute value of size. Acceptable units are B, KiB, MiB, KB, ...
  ## Without quotes and units, interpreted as size in bytes.
  size = 1

  ## Only count files that have not been touched for at least this
  ## duration. If mtime is negative, only count files that have been
  ## touched in this duration. Defaults to "0s".
  mtime = "0s"

####################################################################################################
[[inputs.system]]

#system
#
#    fields:
#        load1 (float)
#        load15 (float)
#        load5 (float)
#        n_users (integer)
#        n_cpus (integer)
#        uptime (integer, seconds)
#        uptime_format (string, deprecated in 1.10, use uptime field)

####################################################################################################
[[inputs.mem]]

#mem
#
#    fields:
#        active (integer, Darwin, FreeBSD, Linux, OpenBSD)
#        available (integer)
#        available_percent (float)
#        buffered (integer, FreeBSD, Linux)
#        cached (integer, FreeBSD, Linux, OpenBSD)
#        commit_limit (integer, Linux)
#        committed_as (integer, Linux)
#        dirty (integer, Linux)
#        free (integer, Darwin, FreeBSD, Linux, OpenBSD)
#        high_free (integer, Linux)
#        high_total (integer, Linux)
#        huge_pages_free (integer, Linux)
#        huge_page_size (integer, Linux)
#        huge_pages_total (integer, Linux)
#        inactive (integer, Darwin, FreeBSD, Linux, OpenBSD)
#        laundry (integer, FreeBSD)
#        low_free (integer, Linux)
#        low_total (integer, Linux)
#        mapped (integer, Linux)
#        page_tables (integer, Linux)
#        shared (integer, Linux)
#        slab (integer, Linux)
#        sreclaimable (integer, Linux)
#        sunreclaim (integer, Linux)
#        swap_cached (integer, Linux)
#        swap_free (integer, Linux)
#        swap_total (integer, Linux)
#        total (integer)
#        used (integer)
#        used_percent (float)
#        vmalloc_chunk (integer, Linux)
#        vmalloc_total (integer, Linux)
#        vmalloc_used (integer, Linux)
#        wired (integer, Darwin, FreeBSD, OpenBSD)
#        write_back (integer, Linux)
#        write_back_tmp (integer, Linux)


####################################################################################################
[[inputs.hddtemp]]

#hddtemp
#
#    tags:
#        device
#        model
#        unit
#        status
#        source
#    fields:
#        temperature

  interval = "1m"

  ## By default, telegraf gathers temps data from all disks detected by the
  ## hddtemp.
  ##
  ## Only collect temps from the selected disks.
  ##
  ## A * as the device name will return the temperature values of all disks.
  ##
  address = "127.0.0.1:7634"
  # devices = ["sda", "*"]

####################################################################################################
[[inputs.diskio]]

#diskio
#
#    tags:
#        name (device name)
#        serial (device serial number)
#    fields:
#        reads (integer, counter)
#        writes (integer, counter)
#        read_bytes (integer, counter, bytes)
#        write_bytes (integer, counter, bytes)
#        read_time (integer, counter, milliseconds)
#        write_time (integer, counter, milliseconds)
#        io_time (integer, counter, milliseconds)
#        weighted_io_time (integer, counter, milliseconds)
#        iops_in_progress (integer, gauge)
#        merged_reads (integer, counter)
#        merged_writes (integer, counter)

  ## By default, telegraf will gather stats for all devices including
  ## disk partitions.
  ## Setting devices will restrict the stats to the specified devices.
  # devices = ["sda", "sdb"]
  ## Uncomment the following line if you need disk serial numbers.
  skip_serial_number = false
  #
  ## On systems which support it, device metadata can be added in the form of
  ## tags.
  ## Currently only Linux is supported via udev properties. You can view
  ## available properties for a device by running:
  ## 'udevadm info -q property -n /dev/sda'
  ## Note: Most, but not all, udev properties can be accessed this way. Properties
  ## that are currently inaccessible include DEVTYPE, DEVNAME, and DEVPATH.
  device_tags = ["ID_SERIAL"]
  #
  ## Using the same metadata source as device_tags, you can also customize the
  ## name of the device via templates.
  ## The 'name_templates' parameter is a list of templates to try and apply to
  ## the device. The template may contain variables in the form of '$PROPERTY' or
  ## '${PROPERTY}'. The first template which does not contain any variables not
  ## present for the device is used as the device name tag.
  ## The typical use case is for LVM volumes, to get the VG/LV name instead of
  ## the near-meaningless DM-0 name.
  # name_templates = ["$ID_FS_LABEL","$DM_VG_NAME/$DM_LV_NAME"]

####################################################################################################
[[inputs.systemd_units]]

#systemd_units:
#
#    tags:
#        name (string, unit name)
#        load (string, load state)
#        active (string, active state)
#        sub (string, sub state)
#    fields:
#        load_code (int, see below)
#        active_code (int, see below)
#        sub_code (int, see below)

  ## Set timeout for systemctl execution
  # timeout = "1s"
  #
  ## Filter for a specific unit type, default is "service", other possible
  ## values are "socket", "target", "device", "mount", "automount", "swap",
  ## "timer", "path", "slice" and "scope ":
  unittype = "service,timer"
  #
  ## Filter for a specific pattern, default is "" (i.e. all), other possible
  ## values are valid pattern for systemctl, e.g. "a*" for all units with
  ## names starting with "a"
  # pattern = ""
  ## pattern = "telegraf* influxdb*"
  ## pattern = "a*"


[[inputs.smart]]

#    smart_device:
#        tags:
#            capacity
#            device
#            enabled
#            model
#            serial_no
#            wwn
#        fields:
#            exit_status
#            health_ok
#            read_error_rate
#            seek_error
#            temp_c
#            udma_crc_errors
#
#    smart_attribute:
#        tags:
#            capacity
#            device
#            enabled
#            fail
#            flags
#            id
#            model
#            name
#            serial_no
#            wwn
#        fields:
#            exit_status
#            raw_value
#            threshold
#            value
#            worst

    ## Optionally specify the path to the smartctl executable
    path_smartctl = "/usr/sbin/smartctl"

    ## Optionally specify the path to the nvme-cli executable
    path_nvme = "/usr/sbin/nvme"

    ## Optionally specify if vendor specific attributes should be propagated for NVMe disk case
    ## ["auto-on"] - automatically find and enable additional vendor specific disk info
    ## ["vendor1", "vendor2", ...] - e.g. "Intel" enable additional Intel specific disk info
    # enable_extensions = ["auto-on"]

    ## On most platforms used cli utilities requires root access.
    ## Setting 'use_sudo' to true will make use of sudo to run smartctl or nvme-cli.
    ## Sudo must be configured to allow the telegraf user to run smartctl or nvme-cli
    ## without a password.
  use_sudo = true

    ## Skip checking disks in this power mode. Defaults to
    ## "standby" to not wake up disks that have stopped rotating.
    ## See --nocheck in the man pages for smartctl.
    ## smartctl version 5.41 and 5.42 have faulty detection of
    ## power mode and might require changing this value to
    ## "never" depending on your disks.
    # nocheck = "standby"

    ## Gather all returned S.M.A.R.T. attribute metrics and the detailed
    ## information from each drive into the 'smart_attribute' measurement.
 attributes = true

    ## Optionally specify devices to exclude from reporting if disks auto-discovery is performed.
    # excludes = [ "/dev/pass6" ]

    ## Optionally specify devices and device type, if unset
    ## a scan (smartctl --scan and smartctl --scan -d nvme) for S.M.A.R.T. devices will be done
    ## and all found will be included except for the excluded in excludes.
    # devices = [ "/dev/ada0 -d atacam", "/dev/nvme0"]

    ## Timeout for the cli command to complete.
    # timeout = "30s"















# WHAT DOES THIS EVEN DO?


#[[inputs.temp]] # Only captures nouveau sensors which monitor the GPU for nvidia-smi can do that better
  # no configuration




# MAYBE





#[[inputs.cpu]]
#  ## Whether to report per-cpu stats or not
#  percpu = true
#  ## Whether to report total system cpu stats or not
#  totalcpu = true
#  ## If true, collect raw CPU time metrics.
#  collect_cpu_time = false
#  ## If true, compute and report the sum of all non-idle CPU states.
#  report_active = false









[[inputs.net]]
#[[inputs.sysstat]]
  ## Path to the sadc command.
  #
  ## On Debian and Arch Linux the default path is /usr/lib/sa/sadc whereas
  ## on RHEL and CentOS the default path is /usr/lib64/sa/sadc
  #sadc_path = "/usr/lib/sysstat/sadc" # required

  ## Path to the sadf command, if it is not in PATH
  # sadf_path = "/usr/bin/sadf"

  ## Activities is a list of activities, that are passed as argument to the
  ## sadc collector utility (e.g: DISK, SNMP etc...)
  ## The more activities that are added, the more data is collected.
  #activities = ["DISK", "XDISK", "INT", "POWER", "SNMP", "IPV6"]

  ## Group metrics to measurements.
  ##
  ## If group is false each metric will be prefixed with a description
  ## and represents itself a measurement.
  ##
  ## If Group is true, corresponding metrics are grouped to a single measurement.
  #group = true

  ## Options for the sadf command. The values on the left represent the sadf options and
  ## the values on the right their description (wich are used for grouping and prefixing metrics).
  ##
  ## Run 'sar -h' or 'man sar' to find out the supported options for your sysstat version.
#  [inputs.sysstat.options]
#	-B = "paging"
#	-b = "io"
#	-d = "disk"             # requires DISK activity
#  -F = "filesystem"
#  -H = "hugepages"
#  "-I ALL" = "interrrupts"
#  "-j ID" = "diskid"
#  "-m ALL" = "power"
#	"-n ALL" = "network"
#	"-P ALL" = "per_cpu"
#	-q = "queue"
#	-R = "mem"
#	-r = "mem_util"
#	-S = "swap_util"
#	-u = "cpu_util"
#	-v = "inode"
#	-W = "swap"
#	-w = "task"
#  -y = "tty"

  ## Device tags can be used to add additional tags for devices. For example the configuration below
  ## adds a tag vg with value rootvg for all metrics with sda devices.
  # [[inputs.sysstat.device_tags.sda]]
  #  vg = "rootvg"
[[inputs.swap]]
